unit uOPCMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons, ExtCtrls, Menus, dOPC, Inifiles, uInspector,
  uExplorer,uSelGroupDlg, activex, dopcserverdlg;

type
  TMainDlg = class(TForm)
    Panel3: TPanel;
    Label12: TLabel;
    LServer: TLabel;
    Label16: TLabel;
    LStartTime: TLabel;
    Label17: TLabel;
    LState: TLabel;
    LInfo: TLabel;
    Label13: TLabel;
    LUpdateTime: TLabel;
    lErrorinfo: TLabel;
    TopPanel: TPanel;
    Label2: TLabel;
    BDisconnect: TSpeedButton;
    bConnect: TSpeedButton;
    ServerCombo: TComboBox;
    PageControl1: TPageControl;
    ExplorerSheet: TTabSheet;
    InspecSheet: TTabSheet;
    OPCServer: TdOPCServer;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Timer1: TTimer;
    Open1: TMenuItem;
    N1: TMenuItem;
    Save1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    NewSession1: TMenuItem;
    bRemoteSelect: TSpeedButton;
    procedure bConnectClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure BDisconnectClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ServerComboDropDown(Sender: TObject);
    procedure OPCServerServerShutdown(Sender: TObject; Reason: String);
    procedure OPCServerError(Sender: TObject; Errorstring: String;
      var RaiseException: Boolean);
    procedure OPCServerDatachange(Sender: TObject;
      ItemList: TdOPCItemList);
    procedure OPCServerConnect(Sender: TObject);
    procedure OPCServerDisconnect(Sender: TObject);
    procedure OPCServerWriteComplete(Sender: TObject;
      ItemList: TdOPCItemList);
    procedure OPCServerWriteError(Sender: TObject;
      ItemList: TdOPCItemList);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure NewSession1Click(Sender: TObject);
    procedure bRemoteSelectClick(Sender: TObject);
  private
    IniFile : TIniFile;
    procedure ClearInfoLabel;
    procedure Connect;
    procedure WMAddItems(var Message: TMessage); message WM_ADDITEMS;
  public
  end;

var
  MainDlg: TMainDlg;

implementation

{$R *.DFM}

procedure DockForm(Source: TControl; Destination: TWinControl);
begin
 if Source = nil then exit;
 if Destination <> nil then
 begin
   Source.ManualDock(Destination ,Destination ,alClient);
   Source.Align := alClient;
   Source.Show;
 end
 else
 begin
   Source.Visible := false;
   Source.ManualDock(nil);
 end;
end;


procedure TMainDlg.Connect;
begin
   if Trim(ServerCombo.Text) <> '' then
   begin
     lErrorInfo.Caption       := '';
     OpcServer.ServerName     := ServerCombo.Text;   // set Servername from Combobox
     OpcServer.Active         := true;               // connect to Server
     IniFile.WriteString('SERVER','LAST',OpcServer.ServerName);
   end
   else
     ShowMessage('first select OPC Server');
end;

procedure TMainDlg.bConnectClick(Sender: TObject);
begin
  Connect;
end;

procedure TMainDlg.Exit1Click(Sender: TObject);
begin
  close;
end;


procedure TMainDlg.BDisconnectClick(Sender: TObject);
begin
 OpcServer.Active := false;
end;


procedure TMainDlg.ClearInfoLabel;
var
  i : integer;
  C : TComponent;
begin
  for i := 0 to ComponentCount-1 do        // clears all Infolabels
  begin
    C := Components[i];
    if (C.Tag = 1) and (C is TLabel) then
      TLabel(C).Caption := '';
  end;
  LServer.Caption := 'not connected';
end;

procedure TMainDlg.Timer1Timer(Sender: TObject);
var
  ServerState : TServerStateRec;
begin
  Timer1.Enabled := false;        // no timer event
  if OPCServer.Active then
  begin
    try
      InspecDlg.ShowGroupState;
      ServerState         := OpcServer.GetState;
      LServer.Caption     := OpcServer.Servername;
      LState.Caption      := ServerstatetoStr(ServerState.ServerState);
      LInfo.Caption       := ServerState.VendorInfo;
      LStartTime.Caption  := DateTimetoStr(ServerState.StartTime);
      LUpdateTime.Caption := DateTimetoStr(ServerState.LastUpdateTime);
      Timer1.Enabled := true;
    except
      Timer1.Enabled   := false;   // no Timer Event
      OPCServer.Active := false;   // if error then disconnect from OPC Server
      ClearInfoLabel;              // Clear infolabels
    end;
  end
  else
    ClearInfoLabel;
end;

procedure TMainDlg.FormCreate(Sender: TObject);
begin
  dOPCInitSecurity;
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
end;

procedure TMainDlg.FormDestroy(Sender: TObject);
begin
  IniFile.Free;
end;

procedure TMainDlg.FormShow(Sender: TObject);
begin
  ServerCombo.Text := IniFile.ReadString('SERVER','LAST','');
  ClearInfoLabel;
  lErrorInfo.Caption   := '';
  InspecDlg.OPCServer := OPCServer;
  DockForm(InspecDlg,InSpecSheet);
  ExplorerDlg.OPCServer := OPCServer;
  DockForm(ExplorerDlg,ExplorerSheet);
end;

procedure TMainDlg.ServerComboDropDown(Sender: TObject);
begin
  if trim(ServerCombo.Items.Text) = '' then  // if no OPC Servernames loaded
  begin
    Screen.Cursor := crHourGlass;
    GetOPCServers(ServerCombo.Items);        // get Servernames from registry
    Screen.Cursor := crDefault;
  end;
end;

procedure TMainDlg.OPCServerServerShutdown(Sender: TObject;
  Reason: String);
begin
  Timer1.Enabled := false;   // no timer
  ClearInfoLabel;            // clear Infolables
  lErrorInfo.Caption :='Disconnect from Server';
end;


procedure TMainDlg.OPCServerError(Sender: TObject; Errorstring: String;
  var RaiseException: Boolean);
begin
  RaiseException := false;
  lErrorInfo.Caption :=ErrorString;
end;

procedure TMainDlg.OPCServerDatachange(Sender: TObject;
  ItemList: TdOPCItemList);
begin
  InspecDlg.OnDataChange(Sender,ItemList);
end;

procedure TMainDlg.OPCServerConnect(Sender: TObject);
begin
   Timer1.Enabled := true;
   if ExplorerDlg <> nil then
    ExplorerDlg.ShowOPCPath;
end;

procedure TMainDlg.OPCServerDisconnect(Sender: TObject);
begin
   ExplorerDlg.HideOPCPath;
end;

// Message from Explorer to Add Items to Inspector
procedure TMainDlg.WMAddItems(var Message: TMessage);
var
  ItemIds    : TStringList;
  GroupNames : TStringList;
  GroupName  : string;

begin
  ItemIds    := TStringlist.Create;
  GroupNames := TStringlist.Create;
  try
    ExplorerDlg.GetSelectedItemIds(ItemIds);
    InspecDlg.GetGroupNames(GroupNames);
    GroupName := SelectGroupDialog(GroupNames);
    if GroupName <> '' then
      InspecDlg.AddItemsToGroup(GroupName,ItemIds);
  finally
   ItemIds.Free;
   GroupNames.Free;
  end;
end;

procedure TMainDlg.OPCServerWriteComplete(Sender: TObject;
  ItemList: TdOPCItemList);
begin
 lErrorInfo.Caption := 'Async write values OK';
end;

procedure TMainDlg.OPCServerWriteError(Sender: TObject;
  ItemList: TdOPCItemList);
begin
  lErrorInfo.Caption := 'Async write values ERROR';
end;

procedure TMainDlg.NewSession1Click(Sender: TObject);
begin
  OPCServer.OPCGroups.RemoveAll;
  OpcServer.Active := false;
  OpcServer.Servername   := '';
  OpcServer.Computername := '';
  ServerCombo.Text := '';
  InspecDlg.Refresh;
end;


procedure TMainDlg.Open1Click(Sender: TObject);
begin
  if Opendialog1.Execute then
  begin
    NewSession1Click(self);
    OpcServer.Loadfromfile(Opendialog1.FileName);
    ServerCombo.Text := OpcServer.Servername;
    InspecDlg.Refresh;
  end;
end;

procedure TMainDlg.Save1Click(Sender: TObject);
begin
  Savedialog1.FileName := Opendialog1.Filename;
  if Savedialog1.Execute then
    OpcServer.SavetoFile(Savedialog1.FileName);
end;


procedure TMainDlg.bRemoteSelectClick(Sender: TObject);
var
 CName,Server, ServerClsId: string;
begin
   CName := OpcServer.Computername;
   if dopcBrowseServer(CName, Server, ServerClsId) then
   begin
     ServerCombo.Text      := ServerClsId;
     //OpcServer.ServerName  := ServerClsId;      // set Servername from Combobox
   end;
   OpcServer.Computername   := CName;
end;

end.
